Attribute VB_Name = "misc"
Declare Function waveOutBreakLoop Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutClose Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutGetDevCaps Lib "winmm.dll" Alias "waveOutGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As WAVEOUTCAPS, ByVal uSize As Long) As Long
Declare Function waveOutGetErrorText Lib "winmm.dll" Alias "waveOutGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long
Declare Function waveOutGetID Lib "winmm.dll" (ByVal hWaveout As Long, lpuDeviceID As Long) As Long
Declare Function waveOutGetNumDevs Lib "winmm.dll" () As Long
Declare Function waveOutGetPitch Lib "winmm.dll" (ByVal hWaveout As Long, lpdwPitch As Long) As Long
Declare Function waveOutGetPlaybackRate Lib "winmm.dll" (ByVal hWaveout As Long, lpdwRate As Long) As Long
Declare Function waveOutGetPosition Lib "winmm.dll" (ByVal hWaveout As Long, lpInfo As MMTIME, ByVal uSize As Long) As Long
Declare Function waveOutGetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Declare Function waveOutMessage Lib "winmm.dll" (ByVal hWaveout As Long, ByVal msg As Long, ByVal dw1 As Long, ByVal dw2 As Long) As Long
Declare Function waveOutOpen Lib "winmm.dll" (lphWaveOut As Long, ByVal uDeviceID As Long, lpFormat As PCMWAVEFORMAT, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Declare Function waveOutPause Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutPrepareHeader Lib "winmm.dll" (ByVal hWaveout As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Declare Function waveOutReset Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutRestart Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutSetPitch Lib "winmm.dll" (ByVal hWaveout As Long, ByVal dwPitch As Long) As Long
Declare Function waveOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Declare Function waveOutSetPlaybackRate Lib "winmm.dll" (ByVal hWaveout As Long, ByVal dwRate As Long) As Long
Declare Function waveOutUnprepareHeader Lib "winmm.dll" (ByVal hWaveout As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Declare Function waveOutWrite Lib "winmm.dll" (ByVal hWaveout As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Type WAVEFORMAT
        wFormatTag As Integer
        nChannels As Integer
        nSamplesPerSec As Long
        nAvgBytesPerSec As Long
        nBlockAlign As Integer
End Type
Type PCMWAVEFORMAT
        wf As WAVEFORMAT
        wBitsPerSample As Integer
End Type
Type WAVEHDR
        lpData As Long
        dwBufferLength As Long
        dwBytesRecorded As Long
        dwUser As Long
        dwFlags As Long
        dwLoops As Long
        lpNext As Long
        Reserved As Long
End Type
Type WAVEOUTCAPS
        wMid As Integer
        wPid As Integer
        vDriverVersion As Long
        szPname As String * 32
        dwFormats As Long
        wChannels As Integer
        dwSupport As Long
End Type

Type MMTIME
        wType As Integer
        u As Long
        v As Long
End Type

Dim hWaveout As Long
Dim wf As PCMWAVEFORMAT
Dim WH As WAVEHDR
Dim WOC As WAVEOUTCAPS

Public Const APU_HZ = 1789772.5
Public Const SAMPLES = 44100
Public Const SEC = 4
Public Octave(7) As Single
Public Buf() As Integer
Private Noise_Long(&H7FFF) As Long
Private Noise_Short(92) As Long


Public Function init() As Boolean
Dim i&, res&, v&

ReDim Buf(SAMPLES * SEC - 1) As Integer
With wf
  .wf.wFormatTag = 1
  .wf.nChannels = 1
  .wf.nSamplesPerSec = SAMPLES
  .wf.nAvgBytesPerSec = SAMPLES * 2
  .wf.nBlockAlign = 4
  .wBitsPerSample = 16
End With

res = waveOutOpen(hWaveout, -1, wf, 0, 0, 0)
If res <> 0 Then
  MsgBox "waveOutOpensF" + CStr(res)
  Exit Function
End If

With WH
  .lpData = VarPtr(Buf(0))
  .dwBufferLength = SAMPLES * SEC * 2
  .dwFlags = 12
  .dwLoops = 1
End With

'h~t@\Vh̎g
Octave(0) = 2 ^ 0
Octave(1) = 2 ^ (2 / 12)
Octave(2) = 2 ^ (4 / 12)
Octave(3) = 2 ^ (5 / 12)
Octave(4) = 2 ^ (7 / 12)
Octave(5) = 2 ^ (9 / 12)
Octave(6) = 2 ^ (11 / 12)
Octave(7) = 2 ^ (12 / 12)

'mCY
v = 1
For i = 0 To &H7FFF
  'ŏʃrbgo
  Noise_Long(i) = IIf(v And &H8000&, 1, 0)
  '14,15bitڂxorŉʂĂ
  v = (v * 2) + (IIf(v And &H4000, 1, 0) Xor IIf(v And &H2000, 1, 0))
  v = v And &HFFFF&
Next

'ZmCY
v = 1
For i = 0 To 92
  'ŏʃrbgo
  Noise_Short(i) = IIf(v And &H8000&, 1, 0)
  '9,15bitڂxorŉʂĂ
  v = (v * 2) + (IIf(v And &H4000, 1, 0) Xor IIf(v And &H100, 1, 0))
  v = v And &HFFFF&
Next



init = True

End Function

Public Sub term()

Call waveOutPause(hWaveout)
Call waveOutReset(hWaveout)
Call waveOutUnprepareHeader(hWaveout, WH, LenB(WH))
Call waveOutClose(hWaveout)

End Sub

Public Sub play()

Call waveOutReset(hWaveout)
Call waveOutPrepareHeader(hWaveout, WH, LenB(WH))
Call waveOutWrite(hWaveout, WH, LenB(WH))
End Sub


Public Sub SaveWave(ByVal filename As String)
Dim fn&, tmp&
Dim PFM As PCMWAVEFORMAT

fn = FreeFile
Open filename For Binary As fn

'RIFFwb_
tmp = &H46464952 ' "RIFF"
Put fn, , tmp

't@CTCY
tmp = 12 + Len(PFM) + 8 + 2 * (UBound(Buf) + 1)
Put fn, , tmp

'WAVEwb_
tmp = &H45564157 ' "WAVE"
Put fn, , tmp

tmp = &H20746D66 ' "fmt "
Put fn, , tmp

tmp = LenB(PFM) 'f[^TCY
Put fn, , tmp

With PFM
  With .wf
    .wFormatTag = 1 'PCM
    .nChannels = 1 'm
    .nSamplesPerSec = SAMPLES 'Hz
    .nAvgBytesPerSec = SAMPLES * 2
    .nBlockAlign = 2
  End With
  .wBitsPerSample = 16
End With
Put fn, , PFM

tmp = &H61746164 ' "data"
Put fn, , tmp
tmp = 2 * (UBound(Buf) + 1)
Put fn, , tmp
Put fn, , Buf()


Close fn


End Sub

Public Sub SquareWave(ByVal FreqMult As Single, ByVal duty As Long, ByVal SweepStyle As Long, _
ByVal dec5 As Boolean, ByVal SweepLen As Long, ByVal SweepShift As Long)

Dim i&, l&, h&
Dim Freq&, rFreq&, sFreq&, Phase!, PhaseDelta!
Dim SweepPhase!, SweepPhaseDelta!
Dim SweepCnt&

'1sec
SweepPhaseDelta = 240 / SAMPLES

For i = 0 To SAMPLES * SEC - 1
  
  '̍̐ݒ
  If (i * 8) Mod (SAMPLES * SEC) = 0 Then
    l = i * 8 \ (SAMPLES * SEC)
    'duty䂪1:7܂łƂ邽߁A8{̎ł܂킷
    Freq = FreqMult * Octave(l) * 8
    
    'ŏFreqɉF͉̐\A
    'ꉞ@̃ASYp
    
    'APỦtickłPH
    rFreq = APU_HZ \ Freq
    
    '1tick̈ʑω
    PhaseDelta = APU_HZ / SAMPLES / rFreq
  End If
  
  'sweepp240HzJE^
  If dec5 Then
    'ϑ96HzA240Hz5̂2E5ڂŃJE^Z
    If SweepPhase < 2 And SweepPhase + SweepPhaseDelta >= 2 Then
      SweepCnt = SweepCnt + 1
    ElseIf dec5 And SweepPhase < 5 And SweepPhase + SweepPhaseDelta >= 5 Then
      SweepCnt = SweepCnt + 1
      SweepPhase = SweepPhase - 5
    End If
  ElseIf SweepPhase < 2 And SweepPhase + SweepPhaseDelta >= 2 Then
   '120Hz240Hz2ɂPJE^Z
    SweepPhase = SweepPhase - 2
    SweepCnt = SweepCnt + 1
  End If
  SweepPhase = SweepPhase + SweepPhaseDelta
  
  'sweeps!
  If SweepCnt >= SweepLen Then
    SweepCnt = SweepCnt - SweepLen
    'VtgʌvZ
    sFreq = rFreq \ (2 ^ SweepShift)
    
    '&h7FF𒴂sweepȂ
    If sFreq < &H7FF Then
      Select Case SweepStyle
      Case 1: rFreq = rFreq + sFreq 'Z
      Case 2: rFreq = rFreq - sFreq 'Z
      Case 3: rFreq = rFreq - sFreq - 1 'Z(␔1)
      End Select
    End If
    
    If rFreq < 8 Then
      PhaseDelta = 0
    Else
      PhaseDelta = APU_HZ / SAMPLES / rFreq
    End If
  End If
  
  'ʑǉ
  Phase = Phase + PhaseDelta
  If Phase >= 8 Then Phase = Phase - 8
  
  h = Int(Phase)
  'dutyl
  Buf(i) = IIf(h < duty, 1, -1) * 10000
Next

End Sub

Public Sub TriWave(ByVal FreqMult As Single)
Dim i&, l&, h&
Dim Freq&, rFreq&, Phase!, PhaseDelta!

For i = 0 To SAMPLES * SEC - 1
  
  '̍̐ݒ
  If (i * 8) Mod (SAMPLES * SEC) = 0 Then
    l = i * 8 \ (SAMPLES * SEC)
    '32iK̈ʑƂ点邽߁A32{̎ł܂킷
    Freq = FreqMult * Octave(l) * 32
    
    'ŏFreqɉF͉̐\A
    'ꉞ@̃ASYp
    
    'APỦtickłPH
    rFreq = APU_HZ \ Freq
    
    '1tick̈ʑω
    PhaseDelta = APU_HZ / SAMPLES / rFreq
  End If
  
  'ʑǉ
  Phase = Phase + PhaseDelta
  If Phase >= 32 Then Phase = Phase - 32
  
  '32iK̈ʑ0,1,2,3... D,E,F,F,E,D ..., 3,2,1,0,0,1,...
  '}bsO
  h = Int(Phase)
  If h >= 16 Then h = 31 - h
  Buf(i) = (h - 7.5) * 1000
Next

End Sub


Public Sub NoiseWave(ByVal LongNoise As Boolean, ByVal LenIndex As Long)
Dim delta!
Dim PhaseLen&, Phase!, Index&

'1sample̎
delta = APU_HZ / SAMPLES
PhaseLen = Choose(LenIndex + 1, 4, 8, 16, 32, 64, 96, 128, 160, _
   202, 254, 380, 508, 762, 1016, 2034, 4068)

For i = 0 To SAMPLES * SEC - 1

  Phase = Phase + delta
  
  'ʑw肵l𒴂
  If Phase \ PhaseLen > 0 Then
    '֐
    Index = (Index + Phase \ PhaseLen) Mod IIf(LongNoise, &H7FFF, 93)
    Phase = Phase - (Phase \ PhaseLen) * PhaseLen
  End If
  
  If LongNoise Then
    Buf(i) = (Noise_Long(Index) - 0.5) * 10000
  Else
    Buf(i) = (Noise_Short(Index) - 0.5) * 10000
  End If
Next

End Sub
